/*
 *  color.h
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *
 */
#ifndef COLOR_H
#define COLOR_H
class Color
{
  public :
    Color();
  Color(double r,double g,double b);
  void normalize();
  double red,green,blue;
  // operation can be performed on a color
  inline Color& Color::assign(double x, double y, double z)
    {
      red = x; green = y; blue = z;
      return *this;
    }
  inline Color& Color::operator +=(const Color& v)
  {
    red += v.red; 
    green += v.green;
    blue += v.blue;
    return *this;
  }
  inline Color& Color::operator *=(double& v)
  {
    red *= v; 
    green *= v;
    blue *= v;
    return *this;
  }
  inline Color& Color::operator *=(const Color& v)
  {
    red *= v.red; 
    green *= v.green;
    blue *= v.blue;
    return *this;
  }
  inline Color& Color::operator =(const Color& v)
  {
    red = v.red; 
    green = v.green;
    blue = v.blue;
    return *this;
  }
}; 
#endif
