
/*
 * Copied from the jungle website. It writes data to a portable pixel map
 * file .... Ahmed Obied ....
 */

#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <stdio.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>

class PixelMap
{
 public:

  PixelMap( const char* );
  PixelMap( FILE* fil);
  PixelMap( GLint, GLint );
  PixelMap( const PixelMap* );
  ~PixelMap();

  void load( const char* );
  void load( FILE* fil );

  inline void pixel ( GLint x, GLint y, GLubyte r, GLubyte g, GLubyte b )
    {
      if (x>=0 && x<w && y>=0 && y<h)
	map[y*w*3+x*3] = r,map[y*w*3+x*3+1]=g,map[y*w*3+x*3+2]=b;
    }

  inline void addpixel ( GLint x, GLint y, GLubyte r, GLubyte g, GLubyte b )
    {
      if (x>=0 && x<w && y>=0 && y<h)
	map[y*w*3+x*3] += r,map[y*w*3+x*3+1]+=g,map[y*w*3+x*3+2]+=b;
    }

  inline void addipixel ( GLint x, GLint y, int r, int g, int b ) {
      if (x>=0 && x<w && y>=0 && y<h)
	map[y*w*3+x*3+0]=((map[y*w*3+x*3+0]+r)<0) ? 0 : map[y*w*3+x*3+0]+r;
	map[y*w*3+x*3+1]=((map[y*w*3+x*3+1]+g)<0) ? 0 : map[y*w*3+x*3+1]+g;
	map[y*w*3+x*3+2]=((map[y*w*3+x*3+2]+b)<0) ? 0 : map[y*w*3+x*3+2]+b;
    }

  inline void subpixel ( GLint x, GLint y, int r, int g, int b ) {
      if (x>=0 && x<w && y>=0 && y<h)
	map[y*w*3+x*3+0]=((map[y*w*3+x*3+0]-r)<0) ? 0 : map[y*w*3+x*3+0]-r;
	map[y*w*3+x*3+1]=((map[y*w*3+x*3+1]-g)<0) ? 0 : map[y*w*3+x*3+1]-g;
	map[y*w*3+x*3+2]=((map[y*w*3+x*3+2]-b)<0) ? 0 : map[y*w*3+x*3+2]-b;
    }

  const GLubyte* pixel ( GLint, GLint ) const;
  GLubyte red ( GLint, GLint ) const;  
  GLubyte green ( GLint, GLint ) const;  
  GLubyte blue ( GLint, GLint ) const;  
  GLubyte component ( GLint, GLint,  GLint ) const;  

  GLint width() const { return w; }
  GLint height() const { return h; }

  const GLubyte* buffer() const{ return map; }
  void reset( GLint, GLint );
  void checkers( GLubyte = 0, GLubyte = 0, GLubyte = 0);
  void backGround(GLubyte cr, GLubyte cg, GLubyte cb);

//  void stripes( GLubyte = 0, GLubyte = 0, GLubyte = 0);  
//  const PixelMap& difference(const PixelMap&);

  friend ostream& operator << ( ostream&, const PixelMap&);


 private:
  int readHeader ( FILE* );
  void whiteSpace( FILE* );
  GLubyte * map;
  GLint w,h;
};
