/*
 *  plane.h
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *
 */

#ifndef PLANE_H
#define PLANE_H
#include "shape.h"
#include "gmVec3.h"

class Plane : public Shape
{
  public :
 Plane();
 
  void setDistance(double d);
  void setNormal(gmVector3 norm);
  void setMin(gmVector3 mi);
  void setMax(gmVector3 ma);
  // inherited
  gmVector3 intersection(gmVector3 p,gmVector3 dir,int &status);
  gmVector3 getNormalVector(gmVector3 point);
  gmVector3 getReflectionVector(gmVector3 dir,gmVector3 normal);
  gmVector3 getTransmissionVector();
  void setMat(Color amb,Color dif,Color spec,
	      double ref, double trans, int shiniess);
  Material getMat();
  double distance;
  gmVector3 normal;
  gmVector3 min,max;
};

#endif 
