
///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// Author : Ahmed Obied                                                      //
// Purpose: definition for the raytracer class                               //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#ifndef RAY_TRACER_H
#define RAY_TRACER_H
#include "gmVec3.h"
#include "color.h"
#include "material.h"
#include "light.h"
#include "shape.h"
#include "vector.h"

class RayTracer
{
  public :
    RayTracer();
  void start();
  void startTracing();
  void outputImage();
  void initLights();
  void initCamera();
  void initScene();
  Color trace(gmVector3 p, gmVector3 direction,int level);
  Color phongShading(gmVector3 intersectionPoint,
		     gmVector3 nVec,
		     gmVector3 rVec,
		     unsigned int index);
  bool shadowFeeler(gmVector3 p,gmVector3 l,unsigned int index);
  void updateLocation();
  vector<Shape*> shapes;
  vector<Light> area_light; 
  gmVector3 eye;
  Color background;
  gmVector3 rayDirection;
  int max;
};

#endif
