/*
 *  shape.cpp
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *
 */

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// Author : Ahmed Obied                                                      //
// Date   : April 4th 2004                                                   //
// Purpose: Create an abstract shape                                         //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#include "shape.h"

//-----------------------------------------------------------------------------
// Parameters    : None
// Return value  : None
// Purpose       : The constructor is not used for any special purpose here
// Method called : Shape
//-----------------------------------------------------------------------------
Shape::Shape()
{
}

//-----------------------------------------------------------------------------
// Parameters    : None
// Return value  : gmVector3
// Purpose       : The function is used as an abstract method for the shape
//                 intersection test
// Method called : Shape
//-----------------------------------------------------------------------------
gmVector3 Shape::intersection(gmVector3 p,gmVector3 dir,int &status)
{
  gmVector3 a;
  return a;
}

//-----------------------------------------------------------------------------
// Parameters    : gmVector3 point
// Return value  : gmVector3
// Purpose       : The function is used as an abstract method for the shape
//                 to get the normal vector
// Method called : getNormalVector
//-----------------------------------------------------------------------------
gmVector3 Shape::getNormalVector(gmVector3 point)
{
  gmVector3 b;
  return b;
}

//-----------------------------------------------------------------------------
// Parameters    : gmVector3 dir,gmVector3 normal
// Return value  : gmVector3
// Purpose       : The function is used as an abstract method for the shape
//                 to get the reflection vector
// Method called : getReflectionVector
//-----------------------------------------------------------------------------
gmVector3 Shape::getReflectionVector(gmVector3 dir,gmVector3 normal)
{
  gmVector3 c;
  return c;
}

//-----------------------------------------------------------------------------
// Parameters    : None
// Return value  : None
// Purpose       : The function is used as an abstract method for the shape
//                 to get the transmission vector
// Method called : getTranmissionVector
//-----------------------------------------------------------------------------
gmVector3 Shape::getTransmissionVector(gmVector3 normal,
				       gmVector3 dir)
{
  gmVector3 d;
  return d;
}

//-----------------------------------------------------------------------------
// Parameters    : None
// Return value  : None
// Purpose       : The function is used as an abstract method for the shape
//                 to get its material
// Method called : getMat
//-----------------------------------------------------------------------------
Material Shape::getMat()
{
  return shapeMat;
}
