/*
 *  shape.h
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *
 */

#ifndef SHAPE_H
#define SHAPE_H
#include "gmVec3.h"
#include "material.h"


class Shape
{
  protected :
    Material shapeMat;
  
  public : 
     Shape();
  
  virtual gmVector3 intersection(gmVector3 p,gmVector3 dir,int &status);
  virtual gmVector3 getNormalVector(gmVector3 point);
  virtual gmVector3 getReflectionVector(gmVector3 dir,gmVector3 normal);
  virtual gmVector3 getTransmissionVector(gmVector3 dir,gmVector3 normal);
  virtual Material getMat();
  
};

#endif
