/*
 *  sphere.h
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *
 */

#ifndef SPHERE_H
#define SPHERE_H
#include "shape.h"

class Sphere : public Shape
{
 
 protected:

  public :
  Sphere();
  
  void setRadius(double r);
  void setCenter(gmVector3 center);
  double getRadius();
  gmVector3 getCenter();
  // inherited
  gmVector3 intersection(gmVector3 p,gmVector3 dir,int &status);
  gmVector3 getNormalVector(gmVector3 point);
  gmVector3 getReflectionVector(gmVector3 dir,gmVector3 normal);
  gmVector3 getTransmissionVector(gmVector3 dir,gmVector3 normal);
  
  void setMat(Color amb,Color dif,Color spec,
	      double ref, double trans, int shiniess);
  Material getMat();
  private :
  
  double radius;
  gmVector3 origin;
 
};
#endif
